option explicit
option keyboard repeat 400,40
option base 0
option default float
option angle degrees

timer=0
mode 1,8
' Aux variables
dim f,i,v, x(2),y(2),z,vi(2),vo(2),tt
' Object data - distance X,Y,Z - Viewplane distance - Vertices and Faces arrays size
const dx=400,dy=300,dz=1000,vp=800,vs=11,fs=19
' Projection matrix
dim px(vs),py(vs)
' Vertices
dim vt(2,vs)
for i=0 to vs
  read vt(0,i):read vt(1,i):read vt(2,i)
next
' Faces
dim f1(fs),f2(fs),f3(fs)
for i=0 to fs
  read f1(i):read f2(i):read f3(i)
next

' Faces colors
dim c(fs)
for i=0 to fs
  read c(i)
next

' Rotation - Angles X,Y,Z - Rotation matrix
const ix=2,iy=1,iz=0.5
dim ax,ay,az, cx,sx, cy,sy, cz,sz, r(2,2)

page write 1
' Main loop
cls
do
  box 192,92,416,416,,0,0

  inc ax,ix
  inc ay,iy
  inc az,iz
  cx=cos(ax):sx=sin(ax)
  cy=cos(ay):sy=sin(ay)
  cz=cos(az):sz=sin(az)
  r(0,0)=cy*cz:r(0,1)=sx*sy*cz-sz*cx:r(0,2)=-sy*cx*cz-sx*sz
  r(1,0)=cy*sz:r(1,1)=cx*cz+sx*sy*sz:r(1,2)=sx*cz-sz*cx*sy
  r(2,0)=sy:r(2,1)=-sx*cy:r(2,2)=cx*cy

  for v=0 to vs
    math slice vt(),,v,vi()
    math v_mult r(),vi(),vo()
    z=vp/(dz-vo(2)):px(v)=vo(0)*z+dx:py(v)=vo(1)*z+dy
  next
  for f=0 to fs
    v=f1(f):x(0)=px(v):y(0)=py(v)
    v=f2(f):x(1)=px(v):y(1)=py(v)
    v=f3(f):x(2)=px(v):y(2)=py(v)
    math v_cross x(),y(),vo()
    if math(sum vo())>0 then
      polygon 3,x(),y(),c(f),c(f)
    end if
  next
  page copy 1 to 0
loop

' Vertices - 12 * 3
data 0,132,213, 0,-132,213, 0,132,-213, 0,-132,-213 
data 132,213,0, -132,213,0, 132,-213,0, -132,-213,0
data 213,0,132, 213,0,-132, -213,0,132, -213,0,-132

' Faces - 20 * 3
data  1, 6, 8,    1, 8, 0,    1, 0,10,    1,10, 7
data  1, 7, 6,    6, 7, 3,    6, 3, 9,    6, 9, 8
data  8, 9, 4,    8, 4, 0,    0, 4, 5,    0, 5,10
data 10, 5,11,   10,11, 7,    7,11, 3,    3,11, 2
data  2,11, 5,    2, 5, 4,    2, 4, 9,    2, 9, 3

' Colors - 20
data rgb(255,0,0)  ,rgb(0,255,0)    ,rgb(0,0,255)  ,rgb(255,255,0)  ,rgb(255,0,255)
data rgb(0,255,255),rgb(255,255,255),rgb(200,0,0)  ,rgb(0,200,0)    ,rgb(0,0,200)
data rgb(200,200,0),rgb(200,0,200)  ,rgb(0,200,200),rgb(200,200,200),rgb(100,0,0)
data rgb(0,100,0)  ,rgb(0,0,100)    ,rgb(100,100,0),rgb(100,0,100)  ,rgb(0,100,100)




